; 

    .486                      ; force 32 bit code
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive
 
  ; -----------------------------------------------------------
  ; uncomment any include file you need for the library module
  ; or add any additional include file that you need.
  ; -----------------------------------------------------------

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\macros\macros.asm

    text_display     PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    RegisterWinClass PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
    RichEdMl         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    TopXY            PROTO :DWORD,:DWORD

  .data?
    hWnde dd ?
    hEdit dd ?
    hInstance dd ?

  .code

; 

text_display proc ptxt:DWORD,parent:DWORD,wd:DWORD,ht:DWORD,WRAP:DWORD

  ; ptxt    = address of zero terminated text to display
  ; parent  = handle of parent window or 0 if none
  ; wd      = required window width in pixels
  ; ht      = required window height in pixels
  ; WRAP    = 0 for no wordwrap, non zero for wrap.

    LOCAL Wtx:DWORD,Wty:DWORD,sw:DWORD,sh:DWORD,icon:DWORD,cursor:DWORD

    mov icon,   FUNC(LoadIcon,NULL,IDI_ASTERISK)
    mov cursor, FUNC(LoadCursor,NULL,IDC_ARROW)
    mov hInstance, rv(GetModuleHandle,NULL)

    STRING szClassName,"View_Text_Class"
    invoke RegisterWinClass,ADDR WndProc,
                            ADDR szClassName,
                            icon,cursor,NULL

    mov sw, FUNC(GetSystemMetrics,SM_CXSCREEN)
    mov sh, FUNC(GetSystemMetrics,SM_CYSCREEN)

    invoke TopXY,wd,sw
    mov Wtx, eax
    invoke TopXY,ht,sh
    mov Wty, eax

    fn CreateWindowEx,WS_EX_LEFT, \
                          ADDR szClassName, \
                          "View Text", \
                          WS_OVERLAPPEDWINDOW, \
                          Wtx,Wty,wd,ht, \
                          parent,NULL, \
                          hInstance,NULL
    mov hWnde,eax

    szText ReDLL,"RICHED32.DLL"
    invoke LoadLibrary,ADDR ReDLL

    invoke RichEdMl,200,90,250,200,hWnde,800,WRAP
    mov hEdit, eax

    invoke GetStockObject,SYSTEM_FIXED_FONT
    invoke SendMessage,hEdit,WM_SETFONT,eax,0
    invoke SendMessage,hEdit,EM_EXLIMITTEXT,0,4000000
    invoke SendMessage,hEdit,EM_SETOPTIONS,ECOOP_XOR,ECO_SELECTIONBAR
    invoke SetWindowText,hEdit,ptxt

    invoke SendMessage,hWnde,WM_SIZE,0,0

    invoke ShowWindow,hWnde,SW_SHOW
    invoke UpdateWindow,hWnde
    invoke UpdateWindow,hEdit

    call MsgLoop
    ret

text_display endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT

    Switch uMsg
      Case WM_CREATE

      case WM_SETFOCUS
        invoke SetFocus,hEdit

      Case WM_SIZE
        invoke GetClientRect,hWin,ADDR Rct
        invoke MoveWindow,hEdit,0,0,Rct.right,Rct.bottom,TRUE
        invoke InvalidateRect,hEdit,ADDR Rct,TRUE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

RichEdMl proc a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,hParent:DWORD,ID:DWORD,WRAP:DWORD

    LOCAL wStyle    :DWORD

    szText EditMl,"RICHEDIT"

    mov wStyle, WS_VISIBLE or \
                WS_CHILDWINDOW or WS_CLIPSIBLINGS or \
                ES_MULTILINE or WS_VSCROLL or \
                ES_AUTOVSCROLL or ES_NOHIDESEL

    .if WRAP == 0
      or wStyle, WS_HSCROLL or ES_AUTOHSCROLL
    .endif

    invoke CreateWindowEx,WS_EX_STATICEDGE,ADDR EditMl,0,wStyle,
                          a,b,wd,ht,hParent,ID,hInstance,NULL
    ret

RichEdMl endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD,sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

    end
